NameYourShip
============

Give your ships names. This mod will let you interact with a ship (Longships, Karves or Rafts) and enter a name for the ship which will then be displayed based on the configuration settings. The interaction location on all of the ships is the area just in front of the mast on the ship's deck (for Longships and Karves, it's between the mast and the storage). Look down at the ship in that location and you should see an option to name the ship (note that if you enable requireKeyPress in the configuration, you'll have to hold the key defined in editKey -- default is RightControl -- to see the interact message).

You can configure the font used, font size, color, the location of the name, how far away you should see the name, whether or not the name fades out as you approach the max distance and whether or not the name should scale based on your distance from the ship (bigger as you get closer, smaller as you get further away). You can also configure whether or not to show the ship's name while you're on it.

Code can be found on [github](https://github.com/FixingDeer/ValheimMods/tree/main/NameYourShip). Issues or change/feature requests can be sent via github or to `@FixingDeer` at the [Valheim Modding Discord](https://discord.gg/BGaQkAS7).


Installation (manual)
---------------------

To install manually:

1.  Move `NameYourShip.dll` from the archive into `<GameDirectory>\BepInEx\plugins`.
2.  Run the game.


Configuration
-------------

modEnabled - true/false to enable the mod (default: true)
requireKeyPress - true/false to enable the requirement to hold a modifier key in order to interact (default: false)
editKey - Modifier key to be held to allow interaction (default: RightControl)
fontName - Font to use to display the ship's name -- must be in the game resources (default: Norsebold)
fontSize - Size of the font to display the ship's name (default: 48)
fontColor - Color of the font (RGBA value) to display the ship's name (default: #FFFFFFFF)
nameLocationLongship - An offset x, y, z value from the Longship's 0, 0, 0 point which is slightly behind the mast and below deck (default: 0, 600, 0)
distanceViewable - How far away should you be able to see the ship's name? (default: 30)
fadeName - true/false to fade the ship's name out as you get further away before it disappears at distanceViewable distance away (default: true)
scaleName - true/false to scale the ship's name based on distance, with it getting smaller the further away you get (default: false)
showNameWhileOnShip - true/false to show the ship's name while on that ship (default: false)


Changelog
---------

#### 0.5.5

-   Update for H&H update
-   Fixed "ShipNameSetter could not be instantiated"

#### 0.5.4

-   Fixed NullReferenceExceptions thrown before the player spawns into the world
-	Changed data type of location variables to improve performance

#### 0.5.3

-   Fixed an issue with the interactable area of the ship being visible

#### 0.5.2

-   Fixed an error placing the interactable area of the ships in the wrong location

#### 0.5.1

-   Fixed the short description of the mod to add Karves and Rafts

#### 0.5.0

-   Added Karves and Rafts
-	Added a config setting to decide whether to show or hide the name of the ship a player is on

#### 0.3.0

-   Initial release